From 1ed70e390130a8d41da99cae1fbd2131c4adcf52 Mon Sep 17 00:00:00 2001
From: Endi Sukma Dewata <edewata@redhat.com>
Date: Fri, 11 Jan 2013 10:51:46 -0500
Subject: [PATCH] Added LDAP exception converter.

A utility class has been added to convert LDAP exceptions into PKI
exceptions.

Ticket #191, #214
---
 .../certsrv/ldap/LDAPExceptionConverter.java       |   46 ++++++++++++++++++++
 .../netscape/cms/servlet/admin/UserService.java    |    7 ++-
 2 files changed, 50 insertions(+), 3 deletions(-)
 create mode 100644 base/common/src/com/netscape/certsrv/ldap/LDAPExceptionConverter.java

diff --git a/base/common/src/com/netscape/certsrv/ldap/LDAPExceptionConverter.java b/base/common/src/com/netscape/certsrv/ldap/LDAPExceptionConverter.java
new file mode 100644
index 0000000000000000000000000000000000000000..dd68795d1dcdb28e1f5b9a8e0006fc57edbdc656
--- /dev/null
+++ b/base/common/src/com/netscape/certsrv/ldap/LDAPExceptionConverter.java
@@ -0,0 +1,46 @@
+// --- BEGIN COPYRIGHT BLOCK ---
+// This program is free software; you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation; version 2 of the License.
+//
+// This program is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License along
+// with this program; if not, write to the Free Software Foundation, Inc.,
+// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+//
+// (C) 2007 Red Hat, Inc.
+// All rights reserved.
+// --- END COPYRIGHT BLOCK ---
+package com.netscape.certsrv.ldap;
+
+import com.netscape.certsrv.base.BadRequestException;
+import com.netscape.certsrv.base.ConflictingOperationException;
+import com.netscape.certsrv.base.PKIException;
+import com.netscape.certsrv.base.ResourceNotFoundException;
+
+import netscape.ldap.LDAPException;
+
+/**
+ * @author Endi S. Dewata
+ */
+public class LDAPExceptionConverter {
+
+    public static PKIException toPKIException(LDAPException e) {
+        switch (e.getLDAPResultCode()) {
+        case LDAPException.ATTRIBUTE_OR_VALUE_EXISTS:
+            return new ConflictingOperationException("Attribute or value exists.", e);
+        case LDAPException.NO_SUCH_OBJECT:
+            return new ResourceNotFoundException("No such object.", e);
+        case LDAPException.INVALID_DN_SYNTAX:
+            return new BadRequestException("Invalid DN syntax.", e);
+        case LDAPException.ENTRY_ALREADY_EXISTS:
+            return new ConflictingOperationException("Entry already exists.", e);
+        default:
+            return new PKIException("LDAP error ("+e.getLDAPResultCode()+"): "+e.getMessage(), e);
+        }
+    }
+}
diff --git a/base/common/src/com/netscape/cms/servlet/admin/UserService.java b/base/common/src/com/netscape/cms/servlet/admin/UserService.java
index 4813d10bec12036682f3eef178f326328a59b112..901d3891cb665c223b57b6971d4700c90d113647 100644
--- a/base/common/src/com/netscape/cms/servlet/admin/UserService.java
+++ b/base/common/src/com/netscape/cms/servlet/admin/UserService.java
@@ -40,6 +40,7 @@ import com.netscape.certsrv.base.PKIException;
 import com.netscape.certsrv.base.UserNotFoundException;
 import com.netscape.certsrv.common.OpDef;
 import com.netscape.certsrv.common.ScopeDef;
+import com.netscape.certsrv.ldap.LDAPExceptionConverter;
 import com.netscape.certsrv.logging.IAuditor;
 import com.netscape.certsrv.logging.ILogger;
 import com.netscape.certsrv.password.IPasswordCheck;
@@ -298,16 +299,16 @@ public class UserService extends PKIService implements UserResource {
                 if (user.getUserID() == null) {
                     throw new BadRequestDataException(getUserMessage("CMS_USRGRP_USER_ADD_FAILED_1", "uid"));
                 } else {
-                    throw new PKIException(getUserMessage("CMS_USRGRP_USER_ADD_FAILED"));
+                    throw new PKIException(e.getMessage(), e);
                 }
 
             } catch (LDAPException e) {
                 log(ILogger.LL_FAILURE, CMS.getLogMessage("ADMIN_SRVLT_ADD_USER_FAIL", e.toString()));
-                throw new PKIException(getUserMessage("CMS_USRGRP_USER_ADD_FAILED"));
+                throw LDAPExceptionConverter.toPKIException(e);
 
             } catch (Exception e) {
                 log(ILogger.LL_FAILURE, e.toString());
-                throw new PKIException(getUserMessage("CMS_USRGRP_USER_ADD_FAILED"));
+                throw new PKIException(e.getMessage(), e);
             }
 
         } catch (PKIException e) {
-- 
1.7.7.1.msysgit.0